'use strict';

document.addEventListener('DOMContentLoaded', function () {
    $('#addgroup').on('click', function () {
        disp();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#addcontact').on('click', function () {
        contact();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#message_button').on('click', function () {
        newMessage();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#contact_button').on('click', function () {
        newContact();
    });
});

document.addEventListener('DOMContentLoaded', function () {
    $('#group_button').on('click', function () {
        newGroup();
    });
});

var number = 0;
updateContacts();
updateGroups();

function disp() {
    var x = document.createElement('INPUT');
    x.setAttribute('id', 'newgroupname');
    x.id = 'newgroupname';
    x.setAttribute('type', 'text');
    document.getElementById('groupadd').innerHTML = '';
    document.getElementById('groupadd').appendChild(x);
    var btn = document.createElement('BUTTON');
    btn.className = 'blue btn';
    btn.onclick = addGroup;
    var txt = document.createTextNode('Add');
    btn.appendChild(txt);
    document.getElementById('groupadd').appendChild(btn);
}

function addGroup() {
    var x = document.getElementById('addgroup');
    var groupName = document.getElementById('newgroupname').value;
    document.getElementById('groupadd').innerHTML = '';
    var ul = document.createElement('ul');
    var li = document.createElement('li');
    li.innerHTML = groupName + ' [-]';
    li.id = number;
    ul.id = number;
    number++;
    var btn = document.createElement('BUTTON');
    var txt = document.createTextNode('del');
    btn.className = 'blue btn';
    btn.appendChild(txt);
    btn.onclick = function () {
        ul.innerHTML = '';
    };
    var innerUl = document.createElement('ul');
    innerUl.id = 'searchResults';
    var plus = document.createElement('li');
    plus.innerHTML = '[+]';
    plus.onclick = '';
    innerUl.appendChild(plus);
    li.appendChild(innerUl);
    ul.appendChild(li);
    ul.appendChild(btn);
    document.getElementById('groups').appendChild(ul);

    chrome.storage.local.get({ groups: [] }, function (result) {
        var groups = result.groups;
        var group = { name: groupName, members: [] };
        groups.push(group);
        chrome.storage.local.set({ groups: groups }, function () {
            updateGroups();
        });
    });
}

function updateGroups() {
    var groups = undefined;
    chrome.storage.local.get({ groups: [] }, function (result) {
        var list = document.getElementById('groups');
        list.innerHTML = '';

        var _loop = function (prop) {
            var _loop2 = function (i) {
                var ul = document.createElement('ul');
                var li = document.createElement('li');
                var name = 'fail';
                try {
                    name = result[prop][i]['name'];
                } catch (err) {
                    name = 'fail';
                }
                li.innerHTML = name;
                var innerUL = document.createElement('ul');
                li.appendChild(innerUL);
                for (var j = 0; j < result[prop][i]['members'].length; j++) {
                    var li2 = document.createElement('li');
                    li2.innerHTML = result[prop][i]['members'][j];
                    innerUL.appendChild(li2);
                }
                ul.appendChild(li);
                list.appendChild(ul);
                var btn = document.createElement('BUTTON');
                btn.className = 'blue btn';
                var txt = document.createTextNode('delete group');
                btn.appendChild(txt);
                btn.onclick = function () {
                    result[prop].splice(i, 1);
                    ul.innerHTML = '';
                    groups = result.groups;
                    chrome.storage.local.set({ groups: groups }, function () {
                        return true;
                    });
                };
                ul.appendChild(btn);
                var drop = document.createElement('SELECT');
                chrome.storage.local.get({ contacts: [] }, function (res) {
                    for (var pro in res) {
                        for (var j = 0; j < res[pro].length; j++) {
                            var opt = document.createElement('option');
                            opt.text = res[pro][j];
                            opt.value = j;
                            drop.add(opt);
                        }
                    }
                });
                ul.appendChild(drop);
                var btn2 = document.createElement('BUTTON');
                btn2.className = 'blue btn';
                var txt2 = document.createTextNode('add member');
                btn2.appendChild(txt2);
                btn2.onclick = function () {
                    result[prop][i]['members'].push(drop.options[drop.value].innerHTML);
                    groups = result.groups;
                    var li2 = document.createElement('li');
                    li2.innerHTML = drop.options[drop.value].innerHTML;
                    innerUL.appendChild(li2);
                    chrome.storage.local.set({ groups: groups }, function () {
                        updateGroups();
                    });
                };
                ul.appendChild(btn2);
                var drop2 = document.createElement('SELECT');
                for (var j = 0; j < result[prop][i]['members'].length; j++) {
                    var opt = document.createElement('option');
                    opt.text = result[prop][i]['members'][j];
                    opt.value = j;
                    drop2.add(opt);
                }
                ul.appendChild(drop2);
                var btn3 = document.createElement('BUTTON');
                btn3.className = 'blue btn';
                var txt3 = document.createTextNode('delete member');
                btn3.appendChild(txt3);
                btn3.onclick = function () {
                    try {
                        result[prop][i]['members'].splice(drop2.value, 1);
                        groups = result.groups;
                        chrome.storage.local.set({ groups: groups }, function () {
                            updateGroups();
                        });
                    } catch (err) {
                        document.getElementById('debug2').innerHTML = result[prop][i]['members'] + ' ' + drop2.value;
                    }
                };
                ul.appendChild(btn3);
            };

            for (var i = 0; i < result[prop].length; i++) {
                _loop2(i);
            }
        };

        for (var prop in result) {
            _loop(prop);
        }
    });
}

function deleteGroup(id) {
    document.getElementById(id).innerHTML = '';
}

function contact() {
    var x = document.createElement('INPUT');
    x.setAttribute('id', 'newcontactname');
    x.id = 'newcontactname';
    x.setAttribute('type', 'text');
    document.getElementById('newcontact').innerHTML = '';
    document.getElementById('newcontact').appendChild(x);
    var btn = document.createElement('BUTTON');
    btn.className = 'blue btn';
    btn.onclick = addContact;
    var txt = document.createTextNode('Add');
    btn.appendChild(txt);
    document.getElementById('newcontact').appendChild(btn);
}

function addContact() {
    var x = document.getElementById('addgroup');
    var contact = document.getElementById('newcontactname').value;
    document.getElementById('newcontact').innerHTML = '';
    var contacts = [];

    chrome.storage.local.get({ contacts: [] }, function (result) {
        var contacts = result.contacts;
        contacts.push(contact);
        chrome.storage.local.set({ contacts: contacts }, function () {
            updateContacts();
            updateGroups();
        });
    });
}

function updateContacts() {
    chrome.storage.local.get({ contacts: [] }, function (result) {
        var list = document.getElementById('contactlist');
        list.innerHTML = '';

        var _loop3 = function (i) {
            var li = document.createElement('li');
            li.innerHTML = result.contacts[i];
            li.onclick = function () {
                list.removeChild(li);
                result.contacts.splice(i, 1);
                var contacts = result.contacts;
                chrome.storage.local.set({ contacts: contacts }, function () {
                    updateGroups();
                    updateContacts();
                });
            };
            list.appendChild(li);
        };

        for (var i = 0; i < result.contacts.length; i++) {
            _loop3(i);
        }
    });
}

function addToStorageList(id, item, callback) {
    chrome.storage.local.get(id, function (result) {
        var ans = result[id] || [];
        ans.push(item);
        chrome.storage.local.set({ id: ans }, callback());
    });
}

function update() {
    updateGroups();
    updateContacts();
}

var StorageManager = function StorageManager() {

    this.addContact = function (localName, publicName, deviceIDs) {
        var _this = this;

        chrome.storage.local.get({ contact: {} }, function (result) {
            var update = result.contact;
            update[localName] = { name: publicName, devices: deviceIDs };
            chrome.storage.local.set({ contact: update }, function () {
                _this.putContacts('contact');
            });
        });
    };

    this.putContacts = function (place) {
        var x;
        chrome.storage.local.get({ contact: {} }, function (result) {
            for (var prop in result.contact) {
                document.getElementById(place).innerHTML += 'local name: ' + prop;
                document.getElementById(place).innerHTML += ', server name: ' + result.contact[prop].name;
                document.getElementById(place).innerHTML += ', registered deviceIDs: ' + result.contact[prop].devices;
            }
        });
    };

    this.updateContact = function () {
        return true;
    };

    this.deleteContact = function (localName) {
        return true;
    };

    this.addGroup = function (name, id, members) {
        var _this2 = this;

        chrome.storage.local.get({ group: {} }, function (result) {
            var update = result.group;
            update[name] = { gid: id, mems: members };
            chrome.storage.local.set({ group: update }, function () {
                _this2.putGroup('group');
            });
        });
    };

    this.putGroup = function (place) {
        chrome.storage.local.get({ group: {} }, function (result) {
            for (var prop in result.group) {
                document.getElementById(place).innerHTML += 'group name: ' + prop;
                document.getElementById(place).innerHTML += ', gid: ' + result.group[prop].gid;
                document.getElementById(place).innerHTML += ', members: ' + result.group[prop].mems;
            }
        });
    };

    this.addGroupMember = function () {
        return true;
    };

    this.deleteGroupMember = function () {
        return true;
    };

    this.deleteGroup = function () {
        return true;
    };

    this.addMessage = function (id, cyphertext, plaintext, contact, group, timestamp) {
        var _this3 = this;

        chrome.storage.local.get({ message: {} }, function (result) {
            var update = result.message;
            update[id] = { cypher: cyphertext, plain: plaintext, con: contact, gro: group, time: timestamp };
            chrome.storage.local.set({ message: update }, function () {
                _this3.putMessage('message');
            });
        });
    };

    this.putMessage = function (place) {
        chrome.storage.local.get({ message: {} }, function (result) {
            for (var prop in result.message) {
                document.getElementById(place).innerHTML += 'mid: ' + prop;
                document.getElementById(place).innerHTML += ', cyphertext: ' + result.message[prop].cypher;
                document.getElementById(place).innerHTML += ', plaintext: ' + result.message[prop].plain;
                document.getElementById(place).innerHTML += ', contact: ' + result.message[prop].con;
                document.getElementById(place).innerHTML += ', group: ' + result.message[prop].gro;
                document.getElementById(place).innerHTML += ', timestamp: ' + result.message[prop].time;
            }
        });
    };

    this.deleteMessage = function (id) {
        chrome.storage.local.get({ message: {} }, function (result) {
            var update = result.message;
            delete update[id];
            chrome.storage.local.set({ message: update }, function (result) {
                return true;
            });
        });
    };
};

var storageManager = new StorageManager();

function newMessage() {
    var mid = document.getElementById('mid').value;
    var cypher = document.getElementById('mcypher').value;
    var plain = document.getElementById('mplain').value;
    var contact = document.getElementById('mcontact').value;
    var group = document.getElementById('mgroup').value;
    var timestamp = document.getElementById('mtimestamp').value;
    storageManager.addMessage(mid, cypher, plain, contact, group, timestamp);
}

function newContact() {
    var localName = document.getElementById('clocal').value;
    var serverName = document.getElementById('cserver').value;
    var device = document.getElementById('cdevice').value;

    storageManager.addContact(localName, serverName, device);
}

function newGroup() {
    var gname = document.getElementById('gname').value;
    var gid = document.getElementById('gid').value;
    var gmembers = document.getElementById('gmembers').value;
    storageManager.addGroup(gname, gid, gmembers);
}